Index: cdr.c
===================================================================
RCS file: /usr/cvsroot/asterisk/cdr.c,v
retrieving revision 1.39
diff -u -r1.39 cdr.c
--- cdr.c	3 Jun 2005 01:42:31 -0000	1.39
+++ cdr.c	15 Jun 2005 06:08:29 -0000
@@ -143,6 +143,22 @@
 	AST_LIST_UNLOCK(&be_list);
 }
 
+static struct ast_cdr *ast_cdr_dup(struct ast_cdr *cdr) 
+{
+	struct ast_cdr *newcdr = NULL;
+
+	if (!(newcdr = ast_cdr_alloc())) {
+		ast_log(LOG_ERROR, "Memory Error!\n");
+	} else {
+		memcpy(newcdr,cdr,sizeof(struct ast_cdr));
+		/* The varshead is unusable, volatile even, after the memcpy so we take care of that here */
+		memset(&newcdr->varshead, 0, sizeof(newcdr->varshead));
+		ast_cdr_copy_vars(newcdr, cdr);
+	}
+
+	return newcdr;
+}
+
 static const char *ast_cdr_getvar_internal(struct ast_cdr *cdr, const char *name, int recur) 
 {
 	struct ast_var_t *variables;
@@ -796,14 +812,15 @@
 	struct ast_flags tmp = {flags};
 	struct ast_cdr *dup;
 
+
 	while (cdr) {
 		/* Detach if post is requested */
 		if (ast_test_flag(&tmp, AST_CDR_FLAG_LOCKED) || !ast_test_flag(cdr, AST_CDR_FLAG_LOCKED)) {
 			if (ast_test_flag(&tmp, AST_CDR_FLAG_POSTED)) {
 				ast_cdr_end(cdr);
-				dup = ast_cdr_alloc();
-				memcpy(dup, cdr, sizeof(*dup));
-				ast_cdr_detach(dup);
+				if ((dup = ast_cdr_dup(cdr))) {
+					ast_cdr_detach(dup);
+				}
 				ast_set_flag(cdr, AST_CDR_FLAG_POSTED);
 			}
 
